<template>
  <div>
    <div class="gva-form-box">
      <el-form :model="formData" ref="elFormRef" label-position="right" :rules="rule" label-width="80px">
        <el-form-item label="地址:" prop="address">
          <el-input v-model="formData.address" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="姓名:" prop="name">
          <el-input v-model="formData.name" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="年龄:" prop="age">
          <el-input v-model.number="formData.age" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="性别 0 女性 1 男性:" prop="sex">
          <el-switch v-model="formData.sex" active-color="#13ce66" inactive-color="#ff4949" active-text="是" inactive-text="否" clearable ></el-switch>
        </el-form-item>
        <el-form-item label="电话:" prop="phone">
          <el-input v-model="formData.phone" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="头像:" prop="photo">
          <el-input v-model="formData.photo" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="公司:" prop="company">
          <el-input v-model="formData.company" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="职务:" prop="position">
          <el-input v-model="formData.position" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="邀请者:" prop="invitor">
          <el-input v-model="formData.invitor" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item>
          <el-button type="primary" @click="save">保存</el-button>
          <el-button type="primary" @click="back">返回</el-button>
        </el-form-item>
      </el-form>
    </div>
  </div>
</template>

<script>
export default {
  name: 'CourseUsers'
}
</script>

<script setup>
import {
  createCourseUsers,
  updateCourseUsers,
  findCourseUsers
} from '@/api/courseUsers'

// 自动获取字典
import { getDictFunc } from '@/utils/format'
import { useRoute, useRouter } from "vue-router"
import { ElMessage } from 'element-plus'
import { ref, reactive } from 'vue'
const route = useRoute()
const router = useRouter()

const type = ref('')
const formData = ref({
            address: '',
            name: '',
            age: 0,
            sex: false,
            phone: '',
            photo: '',
            company: '',
            position: '',
            invitor: '',
        })
// 验证规则
const rule = reactive({
               address : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
               name : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
               age : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
               sex : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
               phone : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
               photo : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
               invitor : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
})

const elFormRef = ref()

// 初始化方法
const init = async () => {
 // 建议通过url传参获取目标数据ID 调用 find方法进行查询数据操作 从而决定本页面是create还是update 以下为id作为url参数示例
    if (route.query.id) {
      const res = await findCourseUsers({ ID: route.query.id })
      if (res.code === 0) {
        formData.value = res.data.recourseUsers
        type.value = 'update'
      }
    } else {
      type.value = 'create'
    }
}

init()
// 保存按钮
const save = async() => {
      elFormRef.value?.validate( async (valid) => {
         if (!valid) return
            let res
           switch (type.value) {
             case 'create':
               res = await createCourseUsers(formData.value)
               break
             case 'update':
               res = await updateCourseUsers(formData.value)
               break
             default:
               res = await createCourseUsers(formData.value)
               break
           }
           if (res.code === 0) {
             ElMessage({
               type: 'success',
               message: '创建/更改成功'
             })
           }
       })
}

// 返回按钮
const back = () => {
    router.go(-1)
}

</script>

<style>
</style>
